//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                                                            b-PSI@Trail_Stairs.mqh |
//|                                    Copyright  2011-12, Igor Stepovoi aka TarasBY |
//|                                                                taras_bulba@tut.by |
//|   13.08.2011     .                          |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|        .  - |
//|      (TarasBY).    - |
//|      ,    .  - |
//|      .                                 |
//|         ,    - |
//| .                                                            |
//|     ,    ,    |
//|     Skype: TarasBY  e-mail.                           |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property copyright "Copyright  2008-12, TarasBY WM R418875277808; Z670270286972"
#property link      "taras_bulba@tut.by"
//IIIIIIIIIIIIIIIIIII==================CONSTANS=================IIIIIIIIIIIIIIIIIIIIII+
//IIIIIIIIIIIIIIIIIII==========  =========IIIIIIIIIIIIIIIIIIIIII+
extern string SETUP_Trailing        = "================== TRAILING ===================";
extern bool   VirtualTrail_ON          = TRUE;             //   
//extern bool   CreatVStopsInChart       = FALSE;            //     
extern bool   TrailLOSS_ON             = TRUE;             //    LOSS`e
extern int    TrailLossAfterBar        = 12;               //      ( )    
extern int    BreakEven                = 30;               // ,        ProfitMIN (   )
extern string Setup_TrailStairs     = "---------------  TrailingStairs ---------------";
extern bool   TrailStairs_ON           = FALSE;            //   "Stairs"
extern double TrailingStop             = 50;               //  -,    
extern int    TrailStep                = 5;                //   ( )
//IIIIIIIIIIIIIIIIIII=========  =======IIIIIIIIIIIIIIIIIIIIII+

//IIIIIIIIIIIIIIIIIII========  =======IIIIIIIIIIIIIIIIIIIIII+
bool          bb_TrailLOSS = false;
//IIIIIIIIIIIIIIIIIII===========  =========IIIIIIIIIIIIIIIIIIIIII+
//bool fInit_Trail()                 //  
//bool fTrail_Position (int fi_Ticket,             // Ticket
                      //int fi_Slippage = 3)       // 
                                     //   
//bool fModify_STOPs (int fi_Ticket,               // Ticket
                    //bool fb_Trail)               //   
                                     //      
//bool fCheck_TrailParameters()      //      
//|***********************************************************************************|
//| :                                                           |
//|***********************************************************************************|
//bool fTrail_Stairs (string fs_Symbol,            // Symbol
                    //int fi_Ticket,               // Ticket
                    //double& fd_NewSL)            //   SL
                                     //  
//bool fMove_ToBreakEven (string fs_Symbol,        // Symbol
                        //int fi_Ticket,           // Ticket
                        //double& fd_NewSL)        //   SL
                                     //     ( )
//|***********************************************************************************|
//| :                                                               |
//|***********************************************************************************|
//void fSet_Values()                 //       
//void fCheck_LibDecimal()           //   
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//                       |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fInit_Trail()
{
    //----         
    fCheck_LibDecimal();
    //----      
    if (!fCheck_TrailParameters())
    {
        Alert ("     !!!");
        bb_OptimContinue = true;
        return (false);
    }
    //----       
    if (TrailLossAfterBar == 0) {TrailLossAfterBar = PERIOD_D1 / Period();}
    //----      
    if (bb_VirtualTrade) bb_CreatVStopsInChart = false;
    //----      GV-
    if (BreakEven > 0 || VirtualTrail_ON)
    {
        bb_ClearGV = true;
        string lsa_Array[1];
        int    li_cnt = 0;
        if (VirtualTrail_ON)
        {
            lsa_Array[li_cnt] = "_#VirtSL";
            li_cnt++;
        }
        if (BreakEven > 0)
        {
            if (li_cnt > 0) ArrayResize (lsa_Array, li_cnt + 1);
            lsa_Array[li_cnt] = "_#BU";
        }
        //----       GV-
        fCreat_ArrayGV (bsa_prefGV, lsa_Array);
    }
//----
    return (true);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//           .                                             |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fTrail_Position (int fi_Ticket,          //  
                     int fi_Slippage = 3)    // 
{
    if (!TrailStairs_ON && BreakEven == 0) return (-1);
//----
    string ls_Symbol = OrderSymbol();
    int    li_Type = OrderType()/*, err = GetLastError()*/;
//----
    //fTrail_Position (li_Ticket, Slippage);
    //----      
    fSet_Values();
    //----      
    bd_Price = fGet_TradePrice (li_Type, bb_RealTrade, ls_Symbol);
    //bs_libNAME = "b-Trail_Stairs";
    //----   
    bd_curSL = fGet_ValueFromGV (StringConcatenate (fi_Ticket, "_#VirtSL"), OrderStopLoss(), VirtualTrail_ON, False);
    bd_NewSL = bd_curSL;
    //----      
    if (TrailLOSS_ON && iBarShift (Symbol(), 0, OrderOpenTime()) > TrailLossAfterBar) {bb_TrailLOSS = true;}
    else {bb_TrailLOSS = false;}
    //----  
    if (TrailStairs_ON)
    {bool lb_Trail = fTrail_Stairs (ls_Symbol, fi_Ticket, bd_NewSL);}
    //----      
    if (fModify_STOPs (fi_Ticket, lb_Trail)) return (1);
    //----    
    if (VirtualTrail_ON)
    {
        if (bd_NewSL > 0.0)
        {
            int li_cmd = 1;
            if (li_Type == OP_SELL) {li_cmd = -1;}
            if (li_cmd * (bd_NewSL - bd_Price) > 0.0)
            {
                RefreshRates();
                bd_Price = fGet_TradePrice (li_Type, bb_RealTrade, ls_Symbol);
                if (fOrderClose (fi_Ticket, OrderLots(), bd_Price, fi_Slippage))
                {fSet_Comment (bdt_curTime, fi_Ticket, 21, "Trail[V_STOP`s]()", True, 1, bd_NewSL); return (0);}
                else fSet_Comment (bdt_curTime, fi_Ticket, 21, "Trail[V_STOP`s]()", False, 1, bd_NewSL);
            }
        }
    }
    //----   
	 fGet_LastErrorInArray (bsa_Comment, "fTrail_Position()", bi_indERR);
//----
    return (-1);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//                                 |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fModify_STOPs (int fi_Ticket,   // Ticket
                    bool fb_Trail)   //   
{
    string ls_Symbol = OrderSymbol();
    bool lb_BreakEven = fMove_ToBreakEven (ls_Symbol, fi_Ticket, bd_NewSL);
//----
    if (!fb_Trail && !lb_BreakEven) return (false);
//----
    int li_Type = OrderType()/*, err = GetLastError()*/;
//----
    //----          (   LOSS)
    if (fCheck_MinProfit (bd_ProfitMIN, bd_NewSL, !bb_TrailLOSS))
    {
        int li_cmd = 1, li_result = -2;
        if (li_Type == OP_SELL) li_cmd = -1;
        //----   SL   
        if (li_cmd * (bd_NewSL - bd_Price) > 0.0) {bd_NewSL = bd_Price;}
        //---- SL     
        if (li_cmd * (bd_NewSL - bd_curSL) > bd_TrailStep || bd_curSL == 0
        //----  SL  
        || lb_BreakEven)
        {
            //----    SL   
            bd_Trail = MathAbs (bd_Price - bd_NewSL);
            //----  
            if (!VirtualTrail_ON)
            {
                li_result = fOrderModify (fi_Ticket, OrderOpenPrice(), bd_NewSL, OrderTakeProfit());
                if (li_result >= 0) fSet_Comment (bdt_curTime, fi_Ticket, 20, "", li_result != 0, VirtualTrail_ON);
                //----    
                if (lb_BreakEven) {if (li_result == 1) GlobalVariableSet (StringConcatenate (fi_Ticket, "_#BU"), bd_NewSL);}
                return (li_result == 1);
            }
            //----   
            else
            {
                //----   SL
                GlobalVariableSet (StringConcatenate (fi_Ticket, "_#VirtSL"), bd_NewSL);
                //----    
                if (lb_BreakEven) {GlobalVariableSet (StringConcatenate (fi_Ticket, "_#BU"), bd_NewSL);}
                if (!bb_VirtualTrade)
                {
                    fSet_Comment (bdt_curTime, fi_Ticket, 20, "b-Trail[Virt]", True, VirtualTrail_ON);
                    //----     
                    if (bb_CreatVStopsInChart) {fDraw_VirtSTOP (bs_NameGV, li_cmd, 0, bd_NewSL);}
                }
            }
        }
    }
    //----   
	 fGet_LastErrorInArray (bsa_Comment, "fModify_STOPs()", bi_indERR);
//----
    return (false);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//              .                       |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fCheck_TrailParameters()
{
    int err = GetLastError();
//----
    if (BreakEven > 0 && BreakEven <= ProfitMIN_Pips)
    {Print (" BreakEven > ProfitMIN_Pips  BreakEven = 0 !!!"); return (false);}
    if (TrailStairs_ON)
    {
        bs_fName = "fTrail_Stairs()";
        if (TrailStep < 1)
        {Print (" TrailStep >= 1 !!!"); return (false);}
        if (TrailLOSS_ON && TrailLossAfterBar < 0)
        {Print (" TrailLossAfterBar >= 0 !!!"); return (false);}
        if (TrailingStop < TrailStep || TrailingStop < BreakEven + ProfitMIN_Pips)
        {Print ("  fTrail_Stairs()  -     ."); return (false);}
    }
    else bs_fName = "";
    //----   
	 fGet_LastErrorInArray (bsa_Comment, "fCheck_TrailParameters()", bi_indERR);
//----
     return (true);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|  -                                                  |
//|    ,    ,          |
//|   ()  "",     ()        |
//| :  +30   +10,  +40 -   +20  ..                         |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fTrail_Stairs (string fs_Symbol,    // Symbol
                    int fi_Ticket,       // Ticket
                    double& fd_NewSL)    //   SL
{
    int li_cmd = 1;
//----
    fd_NewSL = 0.0;
    if (OrderType() == 1) li_cmd = -1;
    if (TrailingStop > 0)
    {
        if (li_cmd * (bd_Price - OrderOpenPrice()) > bd_TrailingStop || bb_TrailLOSS)
        {
            if ((li_cmd * (bd_Price - bd_curSL) > bd_TrailingStop + bd_TrailStep) || bd_curSL == 0.0)
            {fd_NewSL = bd_Price - li_cmd * bd_TrailingStop; bs_fName = "fTrail_Stairs()"; return (true);}
        }
    }
    //----   
	 fGet_LastErrorInArray (bsa_Comment, bs_fName, bi_indERR);
//----
    return (false);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//             ( )                                  |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fMove_ToBreakEven (string fs_Symbol,    // Symbol
                        int fi_Ticket,       // Ticket
                        double& fd_NewSL)    //   SL
{
    string ls_Name = StringConcatenate (fi_Ticket, "_#BU");
//----
    if (GlobalVariableCheck (ls_Name)) return (false);
    //----   
    if (BreakEven > 0)
    {
        int li_cmd = 1, li_Type = OrderType();
        if (li_Type == 1) li_cmd = -1;
        if (li_cmd * (bd_Price - OrderOpenPrice()) > bd_BreakEven)
        {
            double ld_Profit = OrderProfit() + OrderSwap() + OrderCommission();
            //----       
            if (ld_Profit > 0.0)
            {
                fd_NewSL = OrderOpenPrice() + li_cmd * bd_ProfitMIN;
                //GlobalVariableSet (ls_Name, fd_NewSL);
                bs_fName = "fMove_ToBreakEven()";
                fSet_Comment (fi_Ticket, fi_Ticket, 23, bs_fName, True, fd_NewSL);
                return (true);
            }
        }    
    }
    //----   
	 fGet_LastErrorInArray (bsa_Comment, bs_fName, bi_indERR);
//----
    return (false);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+===================================================================================+
//|***********************************************************************************|
//| :                                                               |
//|***********************************************************************************|
//+===================================================================================+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fSet_Values() 
{
    static string ls_Symbol = "";
//----
	 if (ls_Symbol != OrderSymbol())
	 {
		  ls_Symbol = OrderSymbol();
		  bd_ProfitMIN = NDP (ProfitMIN_Pips);
		  bd_BreakEven = NDP (BreakEven);
		  bd_TrailingStop = NDP (TrailingStop);
		  bd_TrailStep = NDP (TrailStep);
	 }
    bd_Spread = NDP (MarketInfo (bs_Symbol, MODE_SPREAD));
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                      |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fCheck_LibDecimal()
{
//----
    TrailingStop *= bi_Decimal;
    TrailStep *= bi_Decimal;
    BreakEven *= bi_Decimal;
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+

